/*
 IOI2001
 Ioiwari


          
   .       
,    IOI.     
       ,  
   .       
,   .  ,  20   
     ,     
  - 2  - 4 .    
.  ,    ,    
        .     
 ,    ,    
         
:
	   1          
5 ,  1         ,   
  1      . 
	 1          1  4 ,  
         ,   
 (0  5   )       
  .

 ,      .  
 ,       .

     .  , 
  Ioiwari     .   
, ..,   ,   .  

  

          . 
    ,     . -, 
     1   7     
       1  7 (    
   ).     .

    .     
   :
	   ,        . 
	    ,      
    (,        
).


 :

            
        .    
    .      
  .       
            .
       .
   ,       
   - V(x), k V(x)    
         .
      .   
   1          
   2       .  :

            MAX { Di + V(Ci) }, ako 1 e  .
    V(x) =
            MIN { -Di + V(Ci) },  2   .

    V(x) = 0, ako     .

 Di e    ,       
       .
    minimax     
 .        
    1   2.     
        1,    
    - 20.
 minimax   -     
     :

    V(x) = MAX { Di - V(Ci) }
    V(x) = 0, ako     .

          
       .
               
     .
      minimax   .
   ,       
  ,        
    ,       
  .      
    6-   (  , 
         5,   - 0),
     -   .

  
*/
#include <fstream.h>

#define SIZE    7
#define INF     1024
#define SPACE   280000

struct state {
  int c[SIZE];

  int code();
  void decode(int);
};

int table[SPACE];
int move[SPACE];

/*
       
 */
int state::code()
{
  int i, cod;

  cod = 0;
  for(i = 0; i < 7; i++)
    cod = cod * 6 + c[i];

  return cod;
}

void state::decode(int cod)
{
  int i;
  
  for(i = 0; i < 7; i++)
  {
    c[i] = cod % 6;
    cod /= 6;
  }
}

/*
       i  
    t.
 */
int playstate(state s, int i, state &t)
{
  int inhand, win = 0;
  
  t = s;
  inhand = t.c[i];
  t.c[i] = 0;
  i++; i %= SIZE;

  while(inhand)
  {
    if(inhand > 1)
    {
      if(t.c[i] == 5)
      {
        t.c[i]--;
        win++;
      }
      else
      {
        inhand--;
        t.c[i]++;
      }
    }
    else
    {
      if(1 <= t.c[i] && t.c[i] <= 4)
      {
        win += t.c[i] + 1;
        t.c[i] = 0;
        inhand = 0;
      }
      else
      {
        inhand--;
        win--;
      }
    }
    i++; i %= SIZE;
  }

  return win;
}

/*
      minimax .
 */
int calcgame(state s)
{
  int i, val, optval, scode;
  state t;
  
  scode = s.code();
  if(table[scode])
    return table[scode];
  
  optval = -INF;
  for(i = 0; i < 7; i++) if(s.c[i])
  {
    val = playstate(s, i, t) - calcgame(t);
    if(val > optval)
    {
      optval = val;
      move[scode] = i;
    }
  }

  if(optval == -INF)
    optval = 0; /*     */
  return table[scode] = optval;
}

/*
      .
 */
void playgame(state s, int pl)
{
  int scode;
  state t;
  
  scode = s.code();
  if(!move[scode]) return;
  if(pl == 0)
    cout << move[scode] + 1 << endl << flush;
  else
  {
    cin >> move[scode];
    move[scode]--;
  }
  playstate(s, move[scode], t);
  playgame(t, !pl);
}

void main()
{
  int i;
  state init;
  
  for(i = 0; i < 7; i++)
    cin >> init.c[i];

  calcgame(init);
  playgame(init, 0);
}
