/*
1
A: I am divine.
1
A: I am lying.
1
A: I am evil.
3
A: B is human.
B: A is evil.
A: B is evil.
0

      ISLAND   , , 3  2001 .
   -------------------------------------------------------------------

   :        : ,
      ; ,      ,
      ,   .    
        .
       ISLAND.EXE,     
      .      
           ,   .

   : ISLAND.IN     (<= 5)  .
           N (<= 50),
       .     
   (A, B, C, D  E)  ,  , ': '    
    :
      I am [not] ( divine | human | evil | lying ).
      X is [not] ( divine | human | evil | lying ).
      It is ( day | night ).
            N = 0.

   :    ISLAND.OUT      
        ,    'Conversation #Y', 

   Y  . .        'This is 
impossible.',
            'No facts are deducible.', 

     .       .  
       ,    ,   :
      X is ( divine | human | evil ).
      It is ( day | night ).
    X - A, B, C, D  .    (  
   )           .  
              .


   : 1)      "".
                 :
              -  ()  //;
              -  () ;
              - / .
                ,      
            -      .

            2)         
 
                 .

            3)         

                  =>     .
                  ,  ,   
              .       
                   ,     
            ,     => .
                       , 
                .

            4)        

                      
                  . .

            5)        , 

            'This is impossible'.
                        
            (,   )     
,
                .
                     /.  .  
             ,        ,  

              =>   .      .

            6) .   ,       
             .     ,      
                  ,    
                .


   :      , /  
     ()  ISLAND.IN / ISLAND.OUT,  ISLAND.C / .

                                                
                                               E-mail: mvalkanov@yahoo.com
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define DIVINE 1
#define HUMAN  2
#define EVIL   4

#define DAY   1
#define NIGHT 2

#define MAX_BEINGS 5
#define MAX_N 50

#define ST_KIND     1
#define ST_LYING    2
#define ST_DAYNIGHT 3

typedef struct { int ckind, kind, kindCnt; } being;
typedef struct { char author, target; int stKind;
                 int day, nt, kind; } statement;

statement smts[MAX_N];

int n;
being b[MAX_BEINGS]; int b_cnt;
int isDay;

int day;

int kinds[3] = { DIVINE, HUMAN, EVIL };
char kindStr[5][7] = { "", "divine", "human", "", "evil" };
int impossible;

void readStatements( FILE * f )
{
   int i;
   char word[20];

   for ( i = 0; i < n; i++ )
   {
      fscanf( f, "%s", word ); smts[i].author = word[0] - 'A';
      if ( smts[i].author >= b_cnt ) b_cnt = smts[i].author + 1;
      fscanf( f, "%s", word );

      if ( strcmp( word, "It" ) == 0 )
      {
         smts[i].stKind = ST_DAYNIGHT;
         fscanf( f, "%s", word );
         fscanf( f, "%s", word );
         smts[i].day = ( strcmp( word, "day." ) == 0 ) ? DAY : NIGHT;
         smts[i].nt = 0;
      }
      else
      {
         if ( word[0] == 'I' )
            smts[i].target = smts[i].author;
         else
            smts[i].target = word[0] - 'A';
         if ( smts[i].target >= b_cnt ) b_cnt = smts[i].target + 1;

         fscanf( f, "%s", word );
         fscanf( f, "%s", word );

         if ( smts[i].nt = ( strcmp( word, "not" ) == 0 ) )
            fscanf( f, "%s", word );

         if ( strcmp( word, "lying." ) == 0 )
            smts[i].stKind = ST_LYING;
         else
         {
            smts[i].stKind = ST_KIND;

            if ( strcmp( word, "divine." ) == 0 )
               smts[i].kind = DIVINE;
            else
            if ( strcmp( word, "human." ) == 0 )
               smts[i].kind = HUMAN;
            else
            if ( strcmp( word, "evil." ) == 0 )
               smts[i].kind = EVIL;
         }
      }
   }
}

int checkStatements( void )
{
   int i;
   int hasToBeTrue;
   int k, kk;

   for ( i = 0; i < n; i++ )
   {
      k = b[ smts[i].author ].ckind;
      hasToBeTrue = ( ( k == DIVINE ) || ( ( k == HUMAN ) && ( day == DAY ) 
) );

      if ( smts[i].nt ) hasToBeTrue = !hasToBeTrue;

      if ( smts[i].stKind == ST_DAYNIGHT )
      {
         if ( ( smts[i].day == day ) != hasToBeTrue ) return 0;
      }
      else
      if ( smts[i].stKind == ST_KIND )
      {
         if ( ( b[ smts[i].target ].ckind == smts[i].kind ) != hasToBeTrue ) 
return 0;
      }
      else
      if ( smts[i].stKind == ST_LYING )
      {
         kk = b[ smts[i].target ].ckind;
         if ( ( ( ( kk == EVIL ) || ( ( kk == HUMAN ) && ( day == NIGHT ) ) 
) ) != hasToBeTrue ) return 0;
      }
   }

   return 1;
}

void rec( int l )
{
   int i;

   if ( l == b_cnt )
   {
      if ( checkStatements() )
      {
         impossible = 0;

         isDay |= day;

         for ( i = 0; i < b_cnt; i++ ) if ( ( b[i].kind & b[i].ckind ) == 0 
)
         {
            b[i].kind |= b[i].ckind;
            b[i].kindCnt++;
         }
      }

      return;
   }

   for ( i = 0; i < 3; i++ )
   {
      b[l].ckind = kinds[i];
      rec( l + 1 );
   }
}

int nofacts = 1;
int conv_cnt = 0;

int main( void )
{
   FILE * f, * t;

//   f = fopen( "island.in", "r" );
//   t = fopen( "island.out", "w" );

   char sTemp[200];
   f = fopen( "island.c", "r" ); fgets( sTemp, 200, f );
   t = stdout;

   for (;;)
   {
      fscanf( f, "%d", &n );
      if ( n == 0 ) break;

      readStatements(f);
      impossible = 1;
      for ( day = DAY; day <= NIGHT; day++ ) rec(0);

      ++conv_cnt;
      fprintf( t, "Conversation #%d", conv_cnt );

      if ( impossible )
         fprintf( t, "\nThis is impossible." );
      else
      {
         int i;

         for ( i = 0; i < b_cnt; i++ ) if ( b[i].kindCnt == 1 )
         {
            nofacts = 0;
            fprintf( t, "\n%c is %s.", i + 'A', kindStr[ b[i].kind ] );
         }

         for ( i = 0; i < b_cnt; i++ )
         {
            b[i].kind = 0;
            b[i].kindCnt = 0;
         }

         b_cnt = 0;

         if ( isDay == DAY )
            { nofacts = 0; fprintf( t, "\nIt is day." ); }
         else
         if ( isDay == NIGHT )
            { nofacts = 0; fprintf( t, "\nIt is night." ); }

         isDay = 0;

         if ( nofacts ) fprintf( t, "\nNo facts are deducible." );

         nofacts = 1;
      }

      fprintf( t, "\n\n" );
   }

   fclose(t);
   fclose(f);

   return 0;
}

