/*
7 11
###########
#T##......#
#.#.#..####
#....B....#
#.######..#
#.....S...#
###########

      LAB   , , 3  2001 .
   ----------------------------------------------------------------

   :         
   N   M  (1 <= N, M <= 30).     :
     '#' - ;
     '.' - ,      ;
     'S' -  ,     ;
     'B' -  ,     ;
     '' -  ,      ;
            ('B'),
        'T'.      
      :     (,
   ,     ,     ) 
      ,      ( 
   ,     ,   ,   
     ..),    .      
        ,      
   ,       .
        LAB.EXE,      
         'T',   
   -   ,       , 
      -    .     
     ,     .

   :          LAB.IN.  
     M  N.    M      
N,
           '#', '.', 'S', 'B'  'T', 
   'S', 'B',  'T'          .

   :     LAB.OUT    'Impossible.',
               'T',
       ,         
    'U', 'D', 'R', 'L', 'u', 'd', 'r'  'l',   
      ,   -    
     - , , , .


   :          
      .  ,     
    :
      -       (  );
      -   ;
      -        ;
           ,  
        .

          ,      
     .       ,
      .        
      .       
         -    
        (, ,   ).

         ,   
    'T'    , ..    
      -    .  , 
      'T'     

     ,        
     BFS-.

        ,    - 
     .    .     
           .  ,  
        -      
        .       
        ,      

        'B'   'T'.   
           ,   
    .        'U', 'D', 'R' 
   'L'.             

    -           
      'u', 'd', 'r'  'l'.

   :          

    ,     256KB ,  

           .

   :      , /  
     ()  LAB.IN / LAB.OUT,  LAB.C / .

                                                
                                               E-mail: mvalkanov@yahoo.com
*/

#include <stdio.h>
#include <string.h>

#define MAX_N 30
#define MAX_M 30

#define FREE 0
#define WALL 1

#define UP    1
#define DOWN  2
#define LEFT  4
#define RIGHT 8

#define MAX_PATH_LEN 8192

int n, m;
char map[MAX_N][MAX_M];
int Tx, Ty, Bx, By, Sx, Sy;

int nTargetMoves = -1, nTargetHumanMoves, nTargetSide;
int nPathLen; char sPath[MAX_PATH_LEN];

typedef struct { char x, y; int nParentIdx, nMoves; } CHumanMoveCell;
typedef struct { char x, y; int nSide;
                 int nParentIdx, nMoves, nHumanMoves; } CBarrelMoveCell;

CHumanMoveCell vHumanMoveQueue[MAX_PATH_LEN];
char bHumanVisited[MAX_N][MAX_M];
int nIR_HMQ, nIW_HMQ;

CBarrelMoveCell vBarrelMoveQueue[MAX_PATH_LEN];
char bBarrelVisited[MAX_N][MAX_M];
int nIR_BMQ, nIW_BMQ;

int vSideReindex[9] = { 0, 0, 1, 0, 2, 0, 0, 0, 3 };
int nBarrelVisitedIdx[MAX_N][MAX_M][4];
int vBarrelIndexPath[MAX_PATH_LEN], nBarrelIndexPathLen;

char sHumanPath[MAX_PATH_LEN]; int nHumanPathLen;

void pMoveHuman( CHumanMoveCell * to, CHumanMoveCell * from )
{
   to->nParentIdx = from - vHumanMoveQueue;
   to->nMoves = from->nMoves + 1;
   bHumanVisited[ to->x ][ to->y ] = 1;
}

int fCanMoveHuman( int tx, int ty, int sx, int sy )
{
   int i;
   CHumanMoveCell * x, * next;

   if ( ( tx == sx ) && ( ty == sy ) ) return 0;

   for ( i = 0; i < n; i++ ) memset( bHumanVisited[i], 0, m );

   nIR_HMQ = 0; nIW_HMQ = 0;

   vHumanMoveQueue[nIW_HMQ].x = sx; vHumanMoveQueue[nIW_HMQ].y = sy;
   vHumanMoveQueue[nIW_HMQ].nParentIdx = -1;
   vHumanMoveQueue[nIW_HMQ].nMoves = 0;
   bHumanVisited[sx][sy] = 1;
   nIW_HMQ++;

   while ( nIR_HMQ != nIW_HMQ )
   {
      x = vHumanMoveQueue + nIR_HMQ; nIR_HMQ++;

      if ( ( x->x > 0 ) && ( map[ x->x - 1 ][ x->y ] != WALL ) &&
           ( !bHumanVisited[ x->x - 1 ][ x->y ] ) )
      {
         next = vHumanMoveQueue + nIW_HMQ; nIW_HMQ++;
         next->x = x->x - 1; next->y = x->y;
         pMoveHuman( next, x );

         if ( ( next->x == tx ) && ( next->y == ty ) ) return next->nMoves;
      }

      if ( ( x->x < n - 1 ) && ( map[ x->x + 1 ][ x->y ] != WALL ) &&
           ( !bHumanVisited[ x->x + 1 ][ x->y ] ) )
      {
         next = vHumanMoveQueue + nIW_HMQ; nIW_HMQ++;
         next->x = x->x + 1; next->y = x->y;
         pMoveHuman( next, x );

         if ( ( next->x == tx ) && ( next->y == ty ) ) return next->nMoves;
      }

      if ( ( x->y > 0 ) && ( map[ x->x ][ x->y - 1 ] != WALL ) &&
           ( !bHumanVisited[ x->x ][ x->y - 1 ] ) )
      {
         next = vHumanMoveQueue + nIW_HMQ; nIW_HMQ++;
         next->x = x->x; next->y = x->y - 1;
         pMoveHuman( next, x );

         if ( ( next->x == tx ) && ( next->y == ty ) ) return next->nMoves;
      }

      if ( ( x->y < m - 1 ) && ( map[ x->x ][ x->y + 1 ] != WALL ) &&
           ( !bHumanVisited[ x->x ][ x->y + 1 ] ) )
      {
         next = vHumanMoveQueue + nIW_HMQ; nIW_HMQ++;
         next->x = x->x; next->y = x->y + 1;
         pMoveHuman( next, x );

         if ( ( next->x == tx ) && ( next->y == ty ) ) return next->nMoves;
      }
   }

   return -1;
}

void pMoveBarrel( int x, int y, int nSide, CBarrelMoveCell * from, int 
nMoves, int nHumanMoves )
{
   CBarrelMoveCell * next;
   int nOldVisit = nBarrelVisitedIdx[x][y][ vSideReindex[ nSide ] ];

   if ( ( ( bBarrelVisited[x][y] & nSide ) == 0 ) ||
        ( ( nMoves == vBarrelMoveQueue[ nOldVisit ].nMoves ) &&
          ( nHumanMoves < vBarrelMoveQueue[ nOldVisit ].nHumanMoves ) ) )
   {
      bBarrelVisited[x][y] |= nSide;
      nBarrelVisitedIdx[x][y][ vSideReindex[ nSide ] ] = nIW_BMQ;

      next = vBarrelMoveQueue + nIW_BMQ; nIW_BMQ++;

      next->x = x; next->y = y;
      next->nSide = nSide;
      next->nMoves = nMoves; next->nHumanMoves = nHumanMoves;
      next->nParentIdx = ( from != NULL ) ? ( from - vBarrelMoveQueue ) : -1;

      if ( ( next->x == Tx ) && ( next->y == Ty ) )
      {
         nTargetMoves = next->nMoves;
         nTargetHumanMoves = next->nHumanMoves;
         nTargetSide = next->nSide;
      }
   }
}

void pBFS( void )
{
   CBarrelMoveCell * x;
   int mx, my, cx, cy;
   int nHumanMoves;

   nIR_BMQ = 0; nIW_BMQ = 0;

   map[Bx][By] = WALL;

   if ( ( nHumanMoves = fCanMoveHuman( Bx, By - 1, Sx, Sy ) ) != -1 )
      pMoveBarrel( Bx, By, UP, NULL, 0, nHumanMoves );

   if ( ( nHumanMoves = fCanMoveHuman( Bx, By + 1, Sx, Sy ) ) != -1 )
      pMoveBarrel( Bx, By, DOWN, NULL, 0, nHumanMoves );

   if ( ( nHumanMoves = fCanMoveHuman( Bx - 1, By, Sx, Sy ) ) != -1 )
      pMoveBarrel( Bx, By, LEFT, NULL, 0, nHumanMoves );

   if ( ( nHumanMoves = fCanMoveHuman( Bx + 1, By, Sx, Sy ) ) != -1 )
      pMoveBarrel( Bx, By, RIGHT, NULL, 0, nHumanMoves );

   map[Bx][By] = FREE;

   while ( nIR_BMQ != nIW_BMQ )
   {
      x = vBarrelMoveQueue + nIR_BMQ; nIR_BMQ++;
      if ( ( nTargetMoves != -1 ) && ( x->nMoves > nTargetMoves ) ) break;

      if ( ( x->nSide == UP ) && ( x->y < m - 1 ) && ( map[ x->x ][ x->y + 1 ] != WALL ) )
         pMoveBarrel( x->x, x->y + 1, UP, x, x->nMoves + 1, x->nHumanMoves );

      if ( ( x->nSide == DOWN ) && ( x->y > 0 ) && ( map[ x->x ][ x->y - 1 ] != WALL ) )
         pMoveBarrel( x->x, x->y - 1, DOWN, x, x->nMoves + 1, x->nHumanMoves );

      if ( ( x->nSide == LEFT ) && ( x->x < n - 1 ) && ( map[ x->x + 1 ][ x->y ] != WALL ) )
         pMoveBarrel( x->x + 1, x->y, LEFT, x, x->nMoves + 1, x->nHumanMoves );

      if ( ( x->nSide == RIGHT ) && ( x->x > 0 ) && ( map[ x->x - 1 ][ x->y ] != WALL ) )
         pMoveBarrel( x->x - 1, x->y, RIGHT, x, x->nMoves + 1, x->nHumanMoves );

      mx = 0; my = 0;

      switch ( x->nSide )
      {
      case UP    : my = -1; break;
      case DOWN  : my = +1; break;
      case LEFT  : mx = -1; break;
      case RIGHT : mx = +1; break;
      default : break;
      }

      cx = x->x + mx; cy = x->y + my;

      map[ x->x ][ x->y ] = WALL;

      if ( x->nSide != UP )
         if ( ( nHumanMoves = fCanMoveHuman( x->x, x->y - 1, cx, cy ) ) != -1 )
           pMoveBarrel( x->x, x->y, UP, x, x->nMoves, x->nHumanMoves + nHumanMoves );

      if ( x->nSide != DOWN )
         if ( ( nHumanMoves = fCanMoveHuman( x->x, x->y + 1, cx, cy ) ) != -1 )
           pMoveBarrel( x->x, x->y, DOWN, x, x->nMoves, x->nHumanMoves + nHumanMoves );

      if ( x->nSide != LEFT )
         if ( ( nHumanMoves = fCanMoveHuman( x->x - 1, x->y, cx, cy ) ) != -1 )
           pMoveBarrel( x->x, x->y, LEFT, x, x->nMoves, x->nHumanMoves + nHumanMoves );

      if ( x->nSide != RIGHT )
         if ( ( nHumanMoves = fCanMoveHuman( x->x + 1, x->y, cx, cy ) ) != -1 )
           pMoveBarrel( x->x, x->y, RIGHT, x, x->nMoves, x->nHumanMoves + nHumanMoves );

      map[ x->x ][ x->y ] = FREE;
   }
}

void pGetHumanPath( int tx, int ty, int sx, int sy )
{
   int i; CHumanMoveCell * x, * parent; char c;

   if ( nHumanPathLen = fCanMoveHuman( tx, ty, sx, sy ) )
   {
      x = vHumanMoveQueue + ( nIW_HMQ - 1 );

      for ( i = nHumanPathLen - 1; i >= 0; i-- )
      {
         parent = vHumanMoveQueue + x->nParentIdx;

         if ( x->x == parent->x + 1 ) c = 'r'; else
         if ( x->x == parent->x - 1 ) c = 'l'; else
         if ( x->y == parent->y + 1 ) c = 'd'; else
         if ( x->y == parent->y - 1 ) c = 'u';

         sHumanPath[i] = c;

         if ( i > 0 ) x = parent;
      }
   }
}

void pGetPath( void )
{
   int i, t; CBarrelMoveCell * x, * parent;
   int mx, my, cx, cy; char c;
   int nBarrelIndexPathLen2;
   int vSides[4] = { UP, DOWN, LEFT, RIGHT };

   for ( i = 0; i < 4; i++ )
      if ( ( t = nBarrelVisitedIdx[Tx][Ty][ vSideReindex[ vSides[i] ] ] ) != 0 )
         if ( ( vBarrelMoveQueue[t].nMoves == nTargetMoves ) &&
              ( vBarrelMoveQueue[t].nHumanMoves < nTargetHumanMoves ) )
         {
            nTargetHumanMoves = vBarrelMoveQueue[t].nHumanMoves;
            nTargetSide = vSides[i];
         }


   nBarrelIndexPathLen = 0;

   x = vBarrelMoveQueue + nBarrelVisitedIdx[Tx][Ty][ vSideReindex[ nTargetSide ] ];

   for (;;)
   {
      vBarrelIndexPath[ nBarrelIndexPathLen++ ] = x - vBarrelMoveQueue;
      if ( x->nParentIdx == - 1 ) break;

      x = vBarrelMoveQueue + x->nParentIdx;
   }

   nBarrelIndexPathLen2 = nBarrelIndexPathLen >> 1;

   for ( i = 0; i < nBarrelIndexPathLen2; i++ )
   {
      t = vBarrelIndexPath[i];
      vBarrelIndexPath[i] = vBarrelIndexPath[ nBarrelIndexPathLen - 1 - i ];
      vBarrelIndexPath[ nBarrelIndexPathLen - 1 - i ] = t;
   }

   x = vBarrelMoveQueue + vBarrelIndexPath[0];

   mx = 0; my = 0;

   switch ( x->nSide )
   {
   case UP    : my = -1; break;
   case DOWN  : my = +1; break;
   case LEFT  : mx = -1; break;
   case RIGHT : mx = +1; break;
   default : break;
   }

   cx = x->x + mx; cy = x->y + my;

   if ( ( cx != Sx ) || ( cy != Sy ) )
   {
      map[ Bx ][ By ] = WALL;
      pGetHumanPath( cx, cy, Sx, Sy );
      map[ Bx ][ By ] = FREE;

      memcpy( sPath + nPathLen, sHumanPath, nHumanPathLen );
      nPathLen += nHumanPathLen;
      sPath[ nPathLen ] = '\0';
   }

   for ( i = 1; i < nBarrelIndexPathLen; i++ )
   {
      x = vBarrelMoveQueue + vBarrelIndexPath[i];
      parent = vBarrelMoveQueue + x->nParentIdx;

      mx = 0; my = 0;

      switch ( parent->nSide )
      {
      case UP    : my = -1; c = 'D'; break;
      case DOWN  : my = +1; c = 'U'; break;
      case LEFT  : mx = -1; c = 'R'; break;
      case RIGHT : mx = +1; c = 'L'; break;
      default : break;
      }

      cx = parent->x - mx; cy = parent->y - my;

      if ( ( x->nSide == parent->nSide ) && ( x->x == cx ) && ( x->y == cy ) )
         sPath[ nPathLen++ ] = c;
      else
      {
         cx = parent->x + mx; cy = parent->y + my;

         mx = 0; my = 0;

         switch ( x->nSide )
         {
         case UP    : my = -1; break;
         case DOWN  : my = +1; break;
         case LEFT  : mx = -1; break;
         case RIGHT : mx = +1; break;
         default : break;
         }

         map[ x->x ][ x->y ] = WALL;
         pGetHumanPath( x->x + mx, x->y + my, cx, cy );
         map[ x->x ][ x->y ] = FREE;

         memcpy( sPath + nPathLen, sHumanPath, nHumanPathLen );
         nPathLen += nHumanPathLen;
         sPath[ nPathLen ] = '\0';
      }
   }
}

int main( void )
{
   int i, j; char sLine[MAX_N + 1];

//   FILE * f = fopen( "lab.in", "r" );
   char sTemp[200];
   FILE * f = fopen( "lab.c", "r" ); fgets( sTemp, 200, f );

   fscanf( f, "%d %d", &m, &n );
   for ( i = 0; i < m; i++ )
   {
      fscanf( f, "%s", sLine );
      for ( j = 0; j < n; j++ )
      {
         switch ( sLine[j] )
         {
         case 'T': Tx = j; Ty = i; sLine[j] = '.'; break;
         case 'B': Bx = j; By = i; sLine[j] = '.'; break;
         case 'S': Sx = j; Sy = i; sLine[j] = '.'; break;
         default : break;
         }

         map[j][i] = ( sLine[j] == '#' ) ? WALL : FREE;
      }
   }

   fclose(f);

   pBFS();
   if ( nTargetMoves != -1 ) pGetPath();

//   f = fopen( "lab.out", "w" );
   f = stdout;
   fprintf( f, "%s", ( nPathLen ) ? sPath : "Impossible." );
   fclose(f);

   return 0;
}

